# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse2015(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'str',
        'updated_at': 'str',
        'owner': 'str',
        'owner_type': 'str',
        'org_id': 'str',
        'links': 'object',
        'name': 'str',
        'description': 'str',
        'administrators': 'list[IaasapiprojectsAdministrators]',
        'members': 'list[IaasapiprojectsAdministrators]',
        'viewers': 'list[IaasapiprojectsAdministrators]',
        'supervisors': 'list[IaasapiprojectsAdministrators]',
        'zones': 'list[ProjectZones]',
        'constraints': 'dict(str, list[object])',
        'operation_timeout': 'int',
        'machine_naming_template': 'str',
        'shared_resources': 'bool',
        'placement_policy': 'str',
        'custom_properties': 'dict(str, str)'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'owner': 'owner',
        'owner_type': 'ownerType',
        'org_id': 'orgId',
        'links': '_links',
        'name': 'name',
        'description': 'description',
        'administrators': 'administrators',
        'members': 'members',
        'viewers': 'viewers',
        'supervisors': 'supervisors',
        'zones': 'zones',
        'constraints': 'constraints',
        'operation_timeout': 'operationTimeout',
        'machine_naming_template': 'machineNamingTemplate',
        'shared_resources': 'sharedResources',
        'placement_policy': 'placementPolicy',
        'custom_properties': 'customProperties'
    }

    def __init__(self, id=None, created_at=None, updated_at=None, owner=None, owner_type=None, org_id=None, links=None, name=None, description=None, administrators=None, members=None, viewers=None, supervisors=None, zones=None, constraints=None, operation_timeout=None, machine_naming_template=None, shared_resources=None, placement_policy=None, custom_properties=None):  # noqa: E501
        """InlineResponse2015 - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._updated_at = None
        self._owner = None
        self._owner_type = None
        self._org_id = None
        self._links = None
        self._name = None
        self._description = None
        self._administrators = None
        self._members = None
        self._viewers = None
        self._supervisors = None
        self._zones = None
        self._constraints = None
        self._operation_timeout = None
        self._machine_naming_template = None
        self._shared_resources = None
        self._placement_policy = None
        self._custom_properties = None
        self.discriminator = None
        self.id = id
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if owner is not None:
            self.owner = owner
        if owner_type is not None:
            self.owner_type = owner_type
        if org_id is not None:
            self.org_id = org_id
        self.links = links
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if administrators is not None:
            self.administrators = administrators
        if members is not None:
            self.members = members
        if viewers is not None:
            self.viewers = viewers
        if supervisors is not None:
            self.supervisors = supervisors
        if zones is not None:
            self.zones = zones
        if constraints is not None:
            self.constraints = constraints
        if operation_timeout is not None:
            self.operation_timeout = operation_timeout
        if machine_naming_template is not None:
            self.machine_naming_template = machine_naming_template
        if shared_resources is not None:
            self.shared_resources = shared_resources
        if placement_policy is not None:
            self.placement_policy = placement_policy
        if custom_properties is not None:
            self.custom_properties = custom_properties

    @property
    def id(self):
        """Gets the id of this InlineResponse2015.  # noqa: E501

        The id of this resource instance  # noqa: E501

        :return: The id of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse2015.

        The id of this resource instance  # noqa: E501

        :param id: The id of this InlineResponse2015.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this InlineResponse2015.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :return: The created_at of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InlineResponse2015.

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :param created_at: The created_at of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this InlineResponse2015.  # noqa: E501

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :return: The updated_at of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this InlineResponse2015.

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :param updated_at: The updated_at of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def owner(self):
        """Gets the owner of this InlineResponse2015.  # noqa: E501

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :return: The owner of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this InlineResponse2015.

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :param owner: The owner of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._owner = owner

    @property
    def owner_type(self):
        """Gets the owner_type of this InlineResponse2015.  # noqa: E501

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :return: The owner_type of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._owner_type

    @owner_type.setter
    def owner_type(self, owner_type):
        """Sets the owner_type of this InlineResponse2015.

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :param owner_type: The owner_type of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._owner_type = owner_type

    @property
    def org_id(self):
        """Gets the org_id of this InlineResponse2015.  # noqa: E501

        The id of the organization this entity belongs to.  # noqa: E501

        :return: The org_id of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this InlineResponse2015.

        The id of the organization this entity belongs to.  # noqa: E501

        :param org_id: The org_id of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def links(self):
        """Gets the links of this InlineResponse2015.  # noqa: E501

        hrefs links  # noqa: E501

        :return: The links of this InlineResponse2015.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this InlineResponse2015.

        hrefs links  # noqa: E501

        :param links: The links of this InlineResponse2015.  # noqa: E501
        :type: object
        """
        if links is None:
            raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    @property
    def name(self):
        """Gets the name of this InlineResponse2015.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse2015.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this InlineResponse2015.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InlineResponse2015.

        A human-friendly description.  # noqa: E501

        :param description: The description of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def administrators(self):
        """Gets the administrators of this InlineResponse2015.  # noqa: E501

        List of administrator users associated with the project. Only administrators can manage project's configuration.  # noqa: E501

        :return: The administrators of this InlineResponse2015.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._administrators

    @administrators.setter
    def administrators(self, administrators):
        """Sets the administrators of this InlineResponse2015.

        List of administrator users associated with the project. Only administrators can manage project's configuration.  # noqa: E501

        :param administrators: The administrators of this InlineResponse2015.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._administrators = administrators

    @property
    def members(self):
        """Gets the members of this InlineResponse2015.  # noqa: E501

        List of member users associated with the project.   # noqa: E501

        :return: The members of this InlineResponse2015.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this InlineResponse2015.

        List of member users associated with the project.   # noqa: E501

        :param members: The members of this InlineResponse2015.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._members = members

    @property
    def viewers(self):
        """Gets the viewers of this InlineResponse2015.  # noqa: E501

        List of viewer users associated with the project.   # noqa: E501

        :return: The viewers of this InlineResponse2015.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._viewers

    @viewers.setter
    def viewers(self, viewers):
        """Sets the viewers of this InlineResponse2015.

        List of viewer users associated with the project.   # noqa: E501

        :param viewers: The viewers of this InlineResponse2015.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._viewers = viewers

    @property
    def supervisors(self):
        """Gets the supervisors of this InlineResponse2015.  # noqa: E501

        List of supervisor users associated with the project.   # noqa: E501

        :return: The supervisors of this InlineResponse2015.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._supervisors

    @supervisors.setter
    def supervisors(self, supervisors):
        """Sets the supervisors of this InlineResponse2015.

        List of supervisor users associated with the project.   # noqa: E501

        :param supervisors: The supervisors of this InlineResponse2015.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._supervisors = supervisors

    @property
    def zones(self):
        """Gets the zones of this InlineResponse2015.  # noqa: E501

        List of Cloud Zones assigned to this project. You can limit deployment to a single region or allow multi-region placement by adding more than one cloud zone to a project. A cloud zone lists available resources. Use tags on resources to control workload placement.  # noqa: E501

        :return: The zones of this InlineResponse2015.  # noqa: E501
        :rtype: list[ProjectZones]
        """
        return self._zones

    @zones.setter
    def zones(self, zones):
        """Sets the zones of this InlineResponse2015.

        List of Cloud Zones assigned to this project. You can limit deployment to a single region or allow multi-region placement by adding more than one cloud zone to a project. A cloud zone lists available resources. Use tags on resources to control workload placement.  # noqa: E501

        :param zones: The zones of this InlineResponse2015.  # noqa: E501
        :type: list[ProjectZones]
        """

        self._zones = zones

    @property
    def constraints(self):
        """Gets the constraints of this InlineResponse2015.  # noqa: E501

        List of storage, network and extensibility constraints to be applied when provisioning through this project.  # noqa: E501

        :return: The constraints of this InlineResponse2015.  # noqa: E501
        :rtype: dict(str, list[object])
        """
        return self._constraints

    @constraints.setter
    def constraints(self, constraints):
        """Sets the constraints of this InlineResponse2015.

        List of storage, network and extensibility constraints to be applied when provisioning through this project.  # noqa: E501

        :param constraints: The constraints of this InlineResponse2015.  # noqa: E501
        :type: dict(str, list[object])
        """

        self._constraints = constraints

    @property
    def operation_timeout(self):
        """Gets the operation_timeout of this InlineResponse2015.  # noqa: E501

        The timeout that should be used for Blueprint operations and Provisioning tasks. The timeout is in seconds  # noqa: E501

        :return: The operation_timeout of this InlineResponse2015.  # noqa: E501
        :rtype: int
        """
        return self._operation_timeout

    @operation_timeout.setter
    def operation_timeout(self, operation_timeout):
        """Sets the operation_timeout of this InlineResponse2015.

        The timeout that should be used for Blueprint operations and Provisioning tasks. The timeout is in seconds  # noqa: E501

        :param operation_timeout: The operation_timeout of this InlineResponse2015.  # noqa: E501
        :type: int
        """

        self._operation_timeout = operation_timeout

    @property
    def machine_naming_template(self):
        """Gets the machine_naming_template of this InlineResponse2015.  # noqa: E501

        The naming template to be used for machines provisioned in this project  # noqa: E501

        :return: The machine_naming_template of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._machine_naming_template

    @machine_naming_template.setter
    def machine_naming_template(self, machine_naming_template):
        """Sets the machine_naming_template of this InlineResponse2015.

        The naming template to be used for machines provisioned in this project  # noqa: E501

        :param machine_naming_template: The machine_naming_template of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._machine_naming_template = machine_naming_template

    @property
    def shared_resources(self):
        """Gets the shared_resources of this InlineResponse2015.  # noqa: E501

        Specifies whether the resources in this projects are shared or not.  # noqa: E501

        :return: The shared_resources of this InlineResponse2015.  # noqa: E501
        :rtype: bool
        """
        return self._shared_resources

    @shared_resources.setter
    def shared_resources(self, shared_resources):
        """Sets the shared_resources of this InlineResponse2015.

        Specifies whether the resources in this projects are shared or not.  # noqa: E501

        :param shared_resources: The shared_resources of this InlineResponse2015.  # noqa: E501
        :type: bool
        """

        self._shared_resources = shared_resources

    @property
    def placement_policy(self):
        """Gets the placement_policy of this InlineResponse2015.  # noqa: E501

        Placement policy for the project. Determines how a zone will be selected for provisioning. DEFAULT or SPREAD.  # noqa: E501

        :return: The placement_policy of this InlineResponse2015.  # noqa: E501
        :rtype: str
        """
        return self._placement_policy

    @placement_policy.setter
    def placement_policy(self, placement_policy):
        """Sets the placement_policy of this InlineResponse2015.

        Placement policy for the project. Determines how a zone will be selected for provisioning. DEFAULT or SPREAD.  # noqa: E501

        :param placement_policy: The placement_policy of this InlineResponse2015.  # noqa: E501
        :type: str
        """

        self._placement_policy = placement_policy

    @property
    def custom_properties(self):
        """Gets the custom_properties of this InlineResponse2015.  # noqa: E501

        The project custom properties which are added to all requests in this project  # noqa: E501

        :return: The custom_properties of this InlineResponse2015.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this InlineResponse2015.

        The project custom properties which are added to all requests in this project  # noqa: E501

        :param custom_properties: The custom_properties of this InlineResponse2015.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse2015, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse2015):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
